VERSION 5.00
Begin VB.Form Form2 
   Caption         =   "Inno Setup - Hilfsprogramm (GES)  2.0.6     (kompatibel zu InnoSetup 2.x)"
   ClientHeight    =   7995
   ClientLeft      =   60
   ClientTop       =   450
   ClientWidth     =   11415
   BeginProperty Font 
      Name            =   "Arial"
      Size            =   9
      Charset         =   0
      Weight          =   400
      Underline       =   0   'False
      Italic          =   0   'False
      Strikethrough   =   0   'False
   EndProperty
   LinkTopic       =   "Form2"
   ScaleHeight     =   7995
   ScaleWidth      =   11415
   StartUpPosition =   2  'Bildschirmmitte
   Begin VB.TextBox txtFiles 
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   4335
      Left            =   240
      MultiLine       =   -1  'True
      ScrollBars      =   3  'Beides
      TabIndex        =   2
      Text            =   "Form2.frx":0000
      Top             =   3480
      Width           =   10935
   End
   Begin VB.TextBox Text1 
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   1095
      Left            =   240
      MultiLine       =   -1  'True
      TabIndex        =   0
      Text            =   "Form2.frx":000A
      Top             =   1080
      Width           =   10935
   End
   Begin VB.TextBox Text2 
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   1095
      Left            =   240
      MultiLine       =   -1  'True
      TabIndex        =   1
      Text            =   "Form2.frx":0076
      Top             =   2280
      Width           =   10935
   End
   Begin VB.Label Label2 
      BackColor       =   &H00C0FFFF&
      Height          =   135
      Left            =   240
      TabIndex        =   5
      Top             =   120
      Width           =   10935
   End
   Begin VB.Label Label1 
      BackColor       =   &H00C0FFFF&
      Caption         =   $"Form2.frx":01A7
      Height          =   375
      Left            =   240
      TabIndex        =   4
      Top             =   600
      Width           =   10935
   End
   Begin VB.Label Label9 
      Alignment       =   2  'Zentriert
      BackColor       =   &H00C0FFFF&
      Caption         =   "Den Inhalt aus den Text-Boxen folgendermassen in den jeweiligen Abschnitt im ""Inno Setup""-Skript einfgen:"
      Height          =   375
      Left            =   240
      TabIndex        =   3
      Top             =   240
      Width           =   10935
   End
End
Attribute VB_Name = "Form2"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit



' Setup.lst auslesen
Private Sub Form_Load()
  
  Dim sLine As String
  Dim sInstallPath As String
  Dim nCount As Long
  Dim sINIFile As String
  Dim sInfo() As String
  
  ' Pfad zur SETUP.LST und den Installationsdateien
  sINIFile = Form1.txtSetupOrdner.Text & "\SETUP.LST"
  sInstallPath = Left$(sINIFile, InStrRev(sINIFile, "\")) & "support\"
  
  txtFiles.Text = "[Files]" & vbCrLf
  
  ' Abschnitt [Bootstrap Files] aulesen
  nCount = 0
  Do
    nCount = nCount + 1
    sLine = INI_Read("Bootstrap Files", "File" & CStr(nCount), "", sINIFile)
      
    ' kein weiterer Eintrag...
    If sLine = "" Then Exit Do
    
    ' Datei-Infos ermitteln und in die korrekte Syntax
    ' von Inno Setup umwandeln
    sLine = CreateInnoSetupLine(sLine, sInstallPath, True)
    txtFiles.Text = txtFiles.Text & sLine & vbCrLf
  Loop
  
  ' Abschnitt [Setup1 Files] auslesen
  nCount = 0
  Do
    nCount = nCount + 1
    sLine = INI_Read("Setup1 Files", "File" & CStr(nCount), "", sINIFile)
      
    ' kein weiterer Eintrag...
    If sLine = "" Then Exit Do
    
    
    ' Datei-Infos ermitteln und in die korrekte Syntax
    ' von Inno Setup umwandeln
    sLine = CreateInnoSetupLine(sLine, sInstallPath)
    txtFiles.Text = txtFiles.Text & sLine & vbCrLf
  Loop
  
End Sub

Private Function CreateInnoSetupLine(ByVal sLine As String, _
                                     ByVal sInstallPath As String, _
                            Optional ByVal bRuntime As Boolean = False) As String
  
  Dim sFile As String
  Dim sPath As String
  Dim sRegister As String
  Dim sShared As String
  Dim sFlags As String
  Dim AZ As String
  
  ' Anfhrungszeichen
  AZ = Chr$(34)
  
  ' Infos ermitteln
  Dim sInfo() As String
  
  sInfo = Split(sLine, ",")
  
  ' Dateiname
  sFile = Mid$(sInfo(0), 2)
  
  ' Pfad-Konstanten umwandeln
  sPath = sInfo(1)
  sPath = Replace(LCase$(sPath), "$(winpath)", "{win}")
  sPath = Replace(LCase$(sPath), "$(winsyspath)", "{sys}")
  sPath = Replace(LCase$(sPath), "$(winsyspathsysfile)", "{sys}")
  sPath = Replace(LCase$(sPath), "$(msdaopath)", "{dao}")
  sPath = Replace(LCase$(sPath), "$(commonfiles)", "{cf}")
  sPath = Replace(LCase$(sPath), "$(apppath)", "{app}")
  
  ' Register?
  sRegister = ""
  If LCase$(sInfo(2)) = "$(dllselfregister)" Then
    sRegister = "regserver noregerror"
  ElseIf LCase$(sInfo(2)) = "$(tlbregister)" Then
    sRegister = "regtypelib noregerror"
  End If
  
  ' Shared?
  sShared = ""
  If LCase$(sInfo(3)) = "$(shared)" Or bRuntime Then
    sShared = "sharedfile"
  End If
  
  ' Inno Setup Flags zusammenstellen
  sFlags = Trim$(sRegister & " " & sShared)
  If bRuntime Then
    sFlags = Trim$("restartreplace uninsneveruninstall " & sFlags)
  ElseIf LCase$(Right$(sFile, 4)) = ".ocx" Then
    sFlags = Trim$("restartreplace " & sFlags)
  End If
  If sFlags <> "" Then sFlags = "; Flags: " & sFlags

  ' Inno Setup File-Eintrag zusammenstellen
  sLine = "Source: " & AZ & sInstallPath & sFile & AZ & "; " & _
    "DestDir: " & AZ & sPath & AZ & "; " & _
    "CopyMode: alwaysskipifsameorolder" & sFlags
  
  CreateInnoSetupLine = sLine
End Function

Private Sub Form_Unload(Cancel As Integer)
    Unload Form1
End Sub
